#include <DualWheelTruck.h> // Подключение библиотеки <DualWheelTruck.h> для работы с моторами
#include <GW_US04.h>

#define TRIG_PIN 4 // Назначение пина, к которому подключен вывод trig ультразвукового дальномера
#define ECHO_PIN 9 // Назначение пина, к которому подключен вывод echo ультразвукового дальномера
#define LEFT_LED 6 // Назначение пина, к которому подключен левый светодиод
#define RIGHT_LED 11 // Назначение пина, к которому подключен правый светодиод
#define BUTTON_START 5 // Назначение пина, к которому подключена тактовая кнопка запуска

bool robot_state=false; // Б.1 - Объявление переменной robot_state и присвоение ей значения false
bool button_state; // Объявление переменной button_state

int speeds=100; // Б.1 - Объявление переменной speeds и присвоение ей значения 100
int counter; // Объявление переменной counter
int timer; // Объявление переменной timer
int distance; // Объявление переменной distance

void button_read(); // Объявление функции button_read()
void zapusk(); // Объявление функции zapusk()
void backward_go(); // Объявление функции backward_go()

DCMotor* motor_right; // Инициализация мотора и присвоение ему имени motor_right
DCMotor* motor_left; // Инициализация мотора и присвоение ему имени motor_left

GW_US04 sonar = GW_US04(TRIG_PIN, ECHO_PIN); // Инициализация ультразвукового дальномера и присвоение ему имени sonar

void setup() {
Board::vertor_PCA(); // Объявление типа используемого контроллера - vertor_PCA

motor_right = new DCMotor(1, 0, true, 5); // Настройка мотора motor_right с применением функции DCMotor(a, b, c, d): подключен к клеммнику 1, прямая полярность подключения мотора, инерционность 5
motor_left = new DCMotor(0, 0, false, 5); // Настройка мотора motor_left с применением функции DCMotor(a, b, c, d): подключен к клеммнику 0, обратная полярность подключения мотора, инерционность 5

motor_right->stop(false); // Команда на остановку вращения мотора motor_right
motor_left->stop(false); // Команда на остановку вращения мотора motor_left

pinMode (LEFT_LED,OUTPUT); // Настройка пина LEFT_LED на вывод
pinMode (RIGHT_LED,OUTPUT); // Настройка пина RIGHT_LED на вывод
pinMode (BUTTON_START,INPUT); // Настройка пина BUTTON_START на ввод
}

void loop() {  

button_read(); // Б.2 - Вызов на исполнение функции button_read
  if(robot_state==true) // Б.3 - Если значение переменной robot_state равно true, то начать выполнение инструкций в скобках
  {   
  zapusk(); // Б.4 - Вызов на исполнение функции zapusk    
  while(robot_state==true) // Б.5 - Выполнение инструкций в скобках пока значение переменной robot_state равно true     
  {
     distance=sonar.scan(); // Б.6 - Сохранение значения, возвращаемого функцией sonar.scan() в переменную distance
     if(distance>10) // Б.7 - Если значение переменной distance больше 10, то
     {
      motor_right->forward(speeds); // Б.9 - Команда на запуск мотора motor_right со скоростью speeds % в прямом направлении
      motor_left->forward(speeds); // Б.9 - Команда на запуск мотора motor_left со скоростью speeds % в прямом направлении
     }
     else // Иначе значение переменной меньше или равно 10
     {
      backward_go(); // Б.8 - Вызов функции, обеспечивающей разворот робота       
     }
     delay(10); // Б.10 - Ожидание 0,01 секунды
     button_state=digitalRead(BUTTON_START); // Б.11 - Сохранение состояния на пине BUTTON_START в переменную button_state
     if(button_state==0) // Б.12 - Если значение переменной button_state равно 0, то 
     {
      robot_state=false; // Б.13 - Присвоение переменной robot_state значение false 
      motor_right->stop(false); // Б.14 - Команда на остановку вращения мотора motor_right
      motor_left->stop(false); // Б.14 - Команда на остановку вращения мотора motor_left      
      delay(1500); // Б.15 - Ожидание 1,5 секунд
     }     
  }
  }
}

void button_read()
{
  button_state=digitalRead(BUTTON_START); // Б.2.1 - Сохранение состояния на пине BUTTON_START в переменную button_state
  if(button_state==0) // Б.2.2 - Если значение переменной button_state равно 0, то 
  {
  delay(10); // Б.2.3 - Ожидание 0,01 с
  button_state=digitalRead(BUTTON_START); // Б.2.4 - Сохранение состояния на пине BUTTON_START в переменную button_state
  if(button_state==0) // Б.2.5 - Если значение переменной button_state равно 0, то 
  {
  do 
  {
   button_state=digitalRead(BUTTON_START); // Б.2.6 - Сохранение состояния на пине BUTTON_START в переменную button_state
  }
  while(button_state==0); // Б.2.7 - Цикл do..while() выполнять до тех пор, пока значение переменной button_state равно 0
   robot_state=true; // Б.2.8 - Присвоение переменной robot_state значение true   
  }
  }
}

void zapusk()
{
  counter=0; // Б.4.1 - Присвоение переменной counter значения 0
  while(counter<3) // Б.4.2 - Инициализация цикла While()
                   // Выполнение цикла, пока значение переменной counter меньше 3                                     
  {
   digitalWrite(LEFT_LED,HIGH); // Б.4.3 - Установить на пине LEFT_LED напряжение, соответствующее уровню "HIGH"
   digitalWrite(RIGHT_LED,HIGH); // Б.4.3 - Установить на пине RIGHT_LED напряжение, соответствующее уровню "HIGH"
   delay(500); // Б.4.4 - Ожидание 0,5 секунды
   digitalWrite(LEFT_LED,LOW); // Б.4.5 - Установить на пине LEFT_LED напряжение, соответствующее уровню "LOW"
   digitalWrite(RIGHT_LED,LOW); // Б.4.5 - Установить на пине RIGHT_LED напряжение, соответствующее уровню "LOW"
   delay(500); // Б.4.6 - Ожидание 0,5 секунд
   counter=counter+1; // Б.4.7 - Увеличение значения переменной counter на 1
  }      
}

void backward_go()
{
  motor_right->stop(false); // Б.8.1 - Команда на остановку вращения мотора motor_right
  motor_left->stop(false); // Б.8.1 - Команда на остановку вращения мотора motor_left      
  motor_right->backward(speeds); // Б.8.2 - Команда на запуск мотора motor_right со скоростью speeds % в обратном направлении
  motor_left->backward(speeds); // Б.8.2 - Команда на запуск мотора motor_left со скоростью speeds % в обратном направлении
  delay(600); // Б.8.3 - Ожидание 0,6 секунд
  motor_right->backward(speeds); // Б.8.4 - Команда на запуск мотора motor_right со скоростью speeds % в обратном направлении
  motor_left->forward(speeds); // Б.8.4 - Команда на запуск мотора motor_left со скоростью speeds % в прямом направлении
  timer=rand()%50+51; // Б.8.5 - Присвоение переменной timer случайного значения от 50 до 100      
  while (timer>0) // Б.8.6 - Цикл While(). Выполнять до тех пор, пока истинно выражение timer>0
  {
    delay(10); // Б.8.8 - Ожидание 0,01 секунды       
    distance=sonar.scan(); // Б.8.9 - Сохранение значения, возвращаемого функцией sonar.scan() в переменную distance
    if(distance<10)  // Б.8.10 - Если значение переменной distance меньше 10, то
    {
     motor_right->backward(speeds); // Б.8.11 - Команда на запуск мотора motor_right со скоростью speeds % в обратном направлении
     motor_left->backward(speeds); // Б.8.11 - Команда на запуск мотора motor_left со скоростью speeds % в обратном направлении
     delay(500); // Б.8.12 - Ожидание 0,5 секунд
     break; // Команда на прерывание цикла разворота робота
    } 
     timer=timer-1; // Б.8.13 - Уменьшение значения переменной timer на 1       
   }
   motor_right->stop(false); // Б.8.7 - Команда на остановку вращения мотора motor_right
   motor_left->stop(false); // Б.8.7 - Команда на остановку вращения мотора motor_left
}
